/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of CD.xs. Do not edit this file, edit CD.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CD.xs"
/*
 * CD.xs - part of the Audio-Cd package.
 * Copyright (C) 1999-2002 by Doug MacEachern
 *
 * When included as part of the Standard Version of Perl or as
 * part of its complete documentation whether printed or
 * otherwise, this work may be distributed only under the terms
 * of Perl's Artistic License as included in the file COPYING.
 * Any distribution of this file or derivatives thereof outside
 * of that package requires that special arrangements be made
 * with copyright holder.
 * 
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "cdaudio.h"
#include "cddb_lookup.h"

typedef struct disc_info   * Audio__CD__Info;
typedef struct track_info  * Audio__CD__Info__Track;
typedef struct disc_data   * Audio__CD__Data;
typedef struct track_data  * Audio__CD__Track;
typedef struct disc_volume * Audio__CD__Volume;
typedef struct __volume    * Audio__CD__VolumeRL;

typedef int Audio__CD;
typedef int Audio__CDDB;

#define CD_Info_present(info) info->disc_present
#define CD_Info_mode(info) info->disc_mode
#define CD_Info_current_frame(info) info->disc_current_frame
#define CD_Info_current_track(info) info->disc_current_track
#define CD_Info_first_track(info) info->disc_first_track
#define CD_Info_total_tracks(info) info->disc_total_tracks
#define CD_Info_timeval(timeval) \
SP -= items; \
XPUSHs(sv_2mortal(newSViv(timeval.minutes))); \
XPUSHs(sv_2mortal(newSViv(timeval.seconds))); \
PUTBACK; return

#define CD_Info_track_time(info) \
CD_Info_timeval(info->disc_track_time)
#define CD_Info_time(info) \
CD_Info_timeval(info->disc_time)
#define CD_Info_length(info) \
CD_Info_timeval(info->disc_length)

#define CD_Info_Track_length(tinfo)     CD_Info_timeval(tinfo->track_length)
#define CD_Info_Track_pos(tinfo)        CD_Info_timeval(tinfo->track_pos)
#define CD_Info_Track_type(tinfo)       tinfo->track_type
#define CD_Info_Track_is_audio(tinfo) \
(tinfo->track_type == CDAUDIO_TRACK_AUDIO)
#define CD_Info_Track_is_data(tinfo) \
(tinfo->track_type == CDAUDIO_TRACK_DATA)

#define CD_Data_title(data) data->data_title
#define CD_Data_artist(data) data->data_artist
#define CD_Data_extended(data) data->data_extended
#define CD_Data_genre(data) cddb_genre(data->data_genre)

#define CD_Track_name(track) track->track_name
#define CD_Track_artist(track) track->track_artist
#define CD_Track_extended(track) track->track_extended

#define CD_Volume_front(vol) &vol->vol_front
#define CD_Volume_back(vol) &vol->vol_back
#define CD_VolumeRL_right(volrl, val) \
(val >= 0 ? volrl->right = val : volrl->right)
#define CD_VolumeRL_left(volrl, val) \
(val >= 0 ? volrl->left = val : volrl->left)

static Audio__CD cd_init(SV *sv_class, char *device)
{
    int id = cd_init_device(device);
    if (id < 0) {
	return 0;
    }
    return id;
}

static SV *CD_Data_track_new(struct track_data *td)
{
    SV *sv = newSV(0);
#if 0
    struct track_data *new_td = (struct track_data *)safemalloc(sizeof(*new_td));
    Copy(td, new_td, 1, struct track_data);
#endif
    sv_setref_pv(sv, "Audio::CD::Track", (void*)td);
    return sv;
}


static SV *CD_Info_track_new(struct track_info *ti)
{
    SV *sv = newSV(0);
    sv_setref_pv(sv, "Audio::CD::Info::Track", (void*)ti);
    return sv;
}


static void boot_Audio__CD_constants(void)
{
    HV *stash = gv_stashpv("Audio::CD", TRUE);
    newCONSTSUB(stash, "PLAYING", newSViv(CDAUDIO_PLAYING));
    newCONSTSUB(stash, "PAUSED", newSViv(CDAUDIO_PAUSED));
    newCONSTSUB(stash, "COMPLETED", newSViv(CDAUDIO_COMPLETED));
    newCONSTSUB(stash, "NOSTATUS", newSViv(CDAUDIO_NOSTATUS));
    newCONSTSUB(stash, "TRACK_AUDIO", newSViv(CDAUDIO_TRACK_AUDIO));
    newCONSTSUB(stash, "TRACK_DATA", newSViv(CDAUDIO_TRACK_DATA));
}

/* XXX */
static int inexact_select_func(void)
{
    return 1;
}

#line 131 "CD.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 275 "CD.c"

XS_EUPXS(XS_Audio__CD_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_init)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sv_class, device=\"/dev/cdrom\"");
    {
	SV *	sv_class = ST(0)
;
	char *	device;
	Audio__CD	RETVAL;

	if (items < 2)
	    device = "/dev/cdrom";
	else {
	    device = (char *)SvPV_nolen(ST(1))
;
	}

	RETVAL = cd_init(sv_class, device);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Audio::CD::DESTROY",
			"cd_desc")
;
#line 137 "CD.xs"
    close(cd_desc);
#line 328 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD_cddb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_cddb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	Audio__CDDB	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::cddb",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;
#line 144 "CD.xs"
    RETVAL = cd_desc;

#line 360 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CDDB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_play); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_play)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "cd_desc, track=1");
    {
	Audio__CD	cd_desc;
	int	track;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::play",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    track = 1;
	else {
	    track = (int)SvIV(ST(1))
;
	}

	RETVAL = cd_play(cd_desc, track);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::stop",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_stop(cd_desc);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_pause); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_pause)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::pause",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_pause(cd_desc);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::resume",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_resume(cd_desc);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_eject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_eject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::eject",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_eject(cd_desc);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::close",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_close(cd_desc);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	Audio__CD__Info	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::stat",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;
#line 179 "CD.xs"
    RETVAL = (Audio__CD__Info)safemalloc(sizeof(*RETVAL));
    cd_stat(cd_desc, RETVAL);

#line 605 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD::Info", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_play_frames); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_play_frames)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cd_desc, startframe, endframe");
    {
	Audio__CD	cd_desc;
	int	startframe = (int)SvIV(ST(1))
;
	int	endframe = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::play_frames",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_play_frames(cd_desc, startframe, endframe);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_play_track_pos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_play_track_pos)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "cd_desc, starttrack, endtrack, startpos");
    {
	Audio__CD	cd_desc;
	int	starttrack = (int)SvIV(ST(1))
;
	int	endtrack = (int)SvIV(ST(2))
;
	int	startpos = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::play_track_pos",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_play_track_pos(cd_desc, starttrack, endtrack, startpos);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_play_track); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_play_track)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cd_desc, starttrack, endtrack");
    {
	Audio__CD	cd_desc;
	int	starttrack = (int)SvIV(ST(1))
;
	int	endtrack = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::play_track",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_play_track(cd_desc, starttrack, endtrack);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_play_pos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_play_pos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cd_desc, track, startpos");
    {
	Audio__CD	cd_desc;
	int	track = (int)SvIV(ST(1))
;
	int	startpos = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::play_pos",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	RETVAL = cd_play_pos(cd_desc, track, startpos);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_track_advance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_track_advance)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "cd_desc, endtrack, minutes, seconds=0");
    {
	Audio__CD	cd_desc;
	int	endtrack = (int)SvIV(ST(1))
;
	int	minutes = (int)SvIV(ST(2))
;
	int	seconds;
#line 218 "CD.xs"
    struct disc_timeval time;

#line 783 "CD.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::track_advance",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    seconds = 0;
	else {
	    seconds = (int)SvIV(ST(3))
;
	}
#line 221 "CD.xs"
    time.minutes = minutes;
    time.seconds = seconds;
    RETVAL = cd_track_advance(cd_desc, endtrack, time);

#line 812 "CD.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_advance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_advance)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "cd_desc, minutes, seconds=0");
    {
	Audio__CD	cd_desc;
	int	minutes = (int)SvIV(ST(1))
;
	int	seconds;
#line 235 "CD.xs"
    struct disc_timeval time;

#line 834 "CD.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::advance",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    seconds = 0;
	else {
	    seconds = (int)SvIV(ST(2))
;
	}
#line 238 "CD.xs"
    time.minutes = minutes;
    time.seconds = seconds;
    RETVAL = cd_advance(cd_desc, time);

#line 863 "CD.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_get_volume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_get_volume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CD	cd_desc;
	Audio__CD__Volume	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::get_volume",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;
#line 250 "CD.xs"
    RETVAL = (struct disc_volume *)safemalloc(sizeof(*RETVAL));
    cd_get_volume(cd_desc, RETVAL);

#line 898 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD::Volume", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD_set_volume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD_set_volume)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cd_desc, vol");
    {
	Audio__CD	cd_desc;
	Audio__CD__Volume	vol;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CD,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::set_volume",
			"cd_desc", "Audio::CD",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::set_volume",
			"vol", "Audio::CD::Volume",
			refstr, ST(1)
		);
	}
;
#line 262 "CD.xs"
    RETVAL = cd_set_volume(cd_desc, *vol);

#line 952 "CD.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_present); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_present)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::present",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_present(info);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::mode",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_mode(info);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_current_track); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_current_track)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::current_track",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_current_track(info);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_first_track); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_first_track)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::first_track",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_first_track(info);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_total_tracks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_total_tracks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::total_tracks",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_total_tracks(info);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_track_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_track_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::track_time",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	CD_Info_track_time(info);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::time",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	CD_Info_time(info);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::length",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;

	CD_Info_length(info);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info_tracks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_tracks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;
#line 306 "CD.xs"
   int track;

#line 1223 "CD.c"
	AV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::tracks",
			"info", "Audio::CD::Info",
			refstr, ST(0)
		);
	}
;
#line 309 "CD.xs"
   RETVAL = newAV();
   for(track = 0; track < info->disc_total_tracks; track++) {
       av_push(RETVAL, CD_Info_track_new(&info->disc_track[track]));
   }

#line 1245 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	Audio__CD__Info	info;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(Audio__CD__Info,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Audio::CD::Info::DESTROY",
			"info")
;
#line 322 "CD.xs"
   safefree(info);
#line 1277 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info__Track_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info__Track_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tinfo");
    {
	Audio__CD__Info__Track	tinfo;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::Track::length",
			"tinfo", "Audio::CD::Info::Track",
			refstr, ST(0)
		);
	}
;

	CD_Info_Track_length(tinfo);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info__Track_pos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info__Track_pos)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tinfo");
    {
	Audio__CD__Info__Track	tinfo;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::Track::pos",
			"tinfo", "Audio::CD::Info::Track",
			refstr, ST(0)
		);
	}
;

	CD_Info_Track_pos(tinfo);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Info__Track_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info__Track_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tinfo");
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::Track::type",
			"tinfo", "Audio::CD::Info::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_Track_type(tinfo);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info__Track_is_audio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info__Track_is_audio)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tinfo");
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::Track::is_audio",
			"tinfo", "Audio::CD::Info::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_Track_is_audio(tinfo);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Info__Track_is_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Info__Track_is_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tinfo");
    {
	Audio__CD__Info__Track	tinfo;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Info::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    tinfo = INT2PTR(Audio__CD__Info__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Info::Track::is_data",
			"tinfo", "Audio::CD::Info::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Info_Track_is_data(tinfo);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_title); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_title)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::title",
			"data", "Audio::CD::Data",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Data_title(data);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_artist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_artist)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::artist",
			"data", "Audio::CD::Data",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Data_artist(data);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_extended); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_extended)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::extended",
			"data", "Audio::CD::Data",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Data_extended(data);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_genre); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_genre)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    {
	Audio__CD__Data	data;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::genre",
			"data", "Audio::CD::Data",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Data_genre(data);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_tracks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_tracks)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "data, disc");
    {
	Audio__CD__Data	data;
	Audio__CD__Info	disc;
#line 371 "CD.xs"
   int track;

#line 1588 "CD.c"
	AV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Data")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::tracks",
			"data", "Audio::CD::Data",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Audio::CD::Info")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    disc = INT2PTR(Audio__CD__Info,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Data::tracks",
			"disc", "Audio::CD::Info",
			refstr, ST(1)
		);
	}
;
#line 374 "CD.xs"
   RETVAL = newAV();
   for(track = 0; track < disc->disc_total_tracks; track++) {
       av_push(RETVAL, CD_Data_track_new(&data->data_track[track]));
   }

#line 1624 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Data_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Data_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    {
	Audio__CD__Data	data;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    data = INT2PTR(Audio__CD__Data,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Audio::CD::Data::DESTROY",
			"data")
;
#line 387 "CD.xs"
   safefree(data);
#line 1656 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Track_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Track_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "track");
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Track::name",
			"track", "Audio::CD::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Track_name(track);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Track_artist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Track_artist)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "track");
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Track::artist",
			"track", "Audio::CD::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Track_artist(track);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Track_extended); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Track_extended)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "track");
    {
	Audio__CD__Track	track;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Track")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    track = INT2PTR(Audio__CD__Track,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Track::extended",
			"track", "Audio::CD::Track",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Track_extended(track);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CDDB_verbose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CDDB_verbose)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sv, flag");
    {
	SV *	sv = ST(0)
;
	int	flag = (int)SvIV(ST(1))
;

	cddb_verbose(sv, flag);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CDDB_discid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CDDB_discid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "h");
    {
	Audio__CDDB	h;
	unsigned long	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CDDB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    h = INT2PTR(Audio__CDDB,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CDDB::discid",
			"h", "Audio::CDDB",
			refstr, ST(0)
		);
	}
;

	RETVAL = cddb_discid(h);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CDDB_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CDDB_lookup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cd_desc");
    {
	Audio__CDDB	cd_desc;
	Audio__CD__Data	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CDDB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cd_desc = INT2PTR(Audio__CDDB,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CDDB::lookup",
			"cd_desc", "Audio::CDDB",
			refstr, ST(0)
		);
	}
;
#line 421 "CD.xs"
    RETVAL = (Audio__CD__Data)safemalloc(sizeof(*RETVAL));
    cddb_lookup(cd_desc, RETVAL);

#line 1842 "CD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD::Data", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Volume_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Volume_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	Audio__CD__Volume	vol;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Audio::CD::Volume::DESTROY",
			"vol")
;
#line 434 "CD.xs"
   safefree(vol);
#line 1874 "CD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__CD__Volume_front); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Volume_front)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	Audio__CD__Volume	vol;
	Audio__CD__VolumeRL	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Volume::front",
			"vol", "Audio::CD::Volume",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Volume_front(vol);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD::VolumeRL", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__Volume_back); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__Volume_back)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	Audio__CD__Volume	vol;
	Audio__CD__VolumeRL	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::Volume")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    vol = INT2PTR(Audio__CD__Volume,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::Volume::back",
			"vol", "Audio::CD::Volume",
			refstr, ST(0)
		);
	}
;

	RETVAL = CD_Volume_back(vol);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Audio::CD::VolumeRL", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__VolumeRL_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__VolumeRL_left)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "volrl, val=-1");
    {
	Audio__CD__VolumeRL	volrl;
	int	val;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::VolumeRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    volrl = INT2PTR(Audio__CD__VolumeRL,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::VolumeRL::left",
			"volrl", "Audio::CD::VolumeRL",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    val = -1;
	else {
	    val = (int)SvIV(ST(1))
;
	}

	RETVAL = CD_VolumeRL_left(volrl, val);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__CD__VolumeRL_right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__CD__VolumeRL_right)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "volrl, val=-1");
    {
	Audio__CD__VolumeRL	volrl;
	int	val;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Audio::CD::VolumeRL")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    volrl = INT2PTR(Audio__CD__VolumeRL,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Audio::CD::VolumeRL::right",
			"volrl", "Audio::CD::VolumeRL",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    val = -1;
	else {
	    val = (int)SvIV(ST(1))
;
	}

	RETVAL = CD_VolumeRL_right(volrl, val);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Audio__CD); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Audio__CD)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Audio::CD::init", XS_Audio__CD_init);
        newXS_deffile("Audio::CD::DESTROY", XS_Audio__CD_DESTROY);
        newXS_deffile("Audio::CD::cddb", XS_Audio__CD_cddb);
        newXS_deffile("Audio::CD::play", XS_Audio__CD_play);
        newXS_deffile("Audio::CD::stop", XS_Audio__CD_stop);
        newXS_deffile("Audio::CD::pause", XS_Audio__CD_pause);
        newXS_deffile("Audio::CD::resume", XS_Audio__CD_resume);
        newXS_deffile("Audio::CD::eject", XS_Audio__CD_eject);
        newXS_deffile("Audio::CD::close", XS_Audio__CD_close);
        newXS_deffile("Audio::CD::stat", XS_Audio__CD_stat);
        newXS_deffile("Audio::CD::play_frames", XS_Audio__CD_play_frames);
        newXS_deffile("Audio::CD::play_track_pos", XS_Audio__CD_play_track_pos);
        newXS_deffile("Audio::CD::play_track", XS_Audio__CD_play_track);
        newXS_deffile("Audio::CD::play_pos", XS_Audio__CD_play_pos);
        newXS_deffile("Audio::CD::track_advance", XS_Audio__CD_track_advance);
        newXS_deffile("Audio::CD::advance", XS_Audio__CD_advance);
        newXS_deffile("Audio::CD::get_volume", XS_Audio__CD_get_volume);
        newXS_deffile("Audio::CD::set_volume", XS_Audio__CD_set_volume);
        newXS_deffile("Audio::CD::Info::present", XS_Audio__CD__Info_present);
        newXS_deffile("Audio::CD::Info::mode", XS_Audio__CD__Info_mode);
        newXS_deffile("Audio::CD::Info::current_track", XS_Audio__CD__Info_current_track);
        newXS_deffile("Audio::CD::Info::first_track", XS_Audio__CD__Info_first_track);
        newXS_deffile("Audio::CD::Info::total_tracks", XS_Audio__CD__Info_total_tracks);
        newXS_deffile("Audio::CD::Info::track_time", XS_Audio__CD__Info_track_time);
        newXS_deffile("Audio::CD::Info::time", XS_Audio__CD__Info_time);
        newXS_deffile("Audio::CD::Info::length", XS_Audio__CD__Info_length);
        newXS_deffile("Audio::CD::Info::tracks", XS_Audio__CD__Info_tracks);
        newXS_deffile("Audio::CD::Info::DESTROY", XS_Audio__CD__Info_DESTROY);
        newXS_deffile("Audio::CD::Info::Track::length", XS_Audio__CD__Info__Track_length);
        newXS_deffile("Audio::CD::Info::Track::pos", XS_Audio__CD__Info__Track_pos);
        newXS_deffile("Audio::CD::Info::Track::type", XS_Audio__CD__Info__Track_type);
        newXS_deffile("Audio::CD::Info::Track::is_audio", XS_Audio__CD__Info__Track_is_audio);
        newXS_deffile("Audio::CD::Info::Track::is_data", XS_Audio__CD__Info__Track_is_data);
        newXS_deffile("Audio::CD::Data::title", XS_Audio__CD__Data_title);
        newXS_deffile("Audio::CD::Data::artist", XS_Audio__CD__Data_artist);
        newXS_deffile("Audio::CD::Data::extended", XS_Audio__CD__Data_extended);
        newXS_deffile("Audio::CD::Data::genre", XS_Audio__CD__Data_genre);
        newXS_deffile("Audio::CD::Data::tracks", XS_Audio__CD__Data_tracks);
        newXS_deffile("Audio::CD::Data::DESTROY", XS_Audio__CD__Data_DESTROY);
        newXS_deffile("Audio::CD::Track::name", XS_Audio__CD__Track_name);
        newXS_deffile("Audio::CD::Track::artist", XS_Audio__CD__Track_artist);
        newXS_deffile("Audio::CD::Track::extended", XS_Audio__CD__Track_extended);
        newXS_deffile("Audio::CDDB::verbose", XS_Audio__CDDB_verbose);
        newXS_deffile("Audio::CDDB::discid", XS_Audio__CDDB_discid);
        newXS_deffile("Audio::CDDB::lookup", XS_Audio__CDDB_lookup);
        newXS_deffile("Audio::CD::Volume::DESTROY", XS_Audio__CD__Volume_DESTROY);
        newXS_deffile("Audio::CD::Volume::front", XS_Audio__CD__Volume_front);
        newXS_deffile("Audio::CD::Volume::back", XS_Audio__CD__Volume_back);
        newXS_deffile("Audio::CD::VolumeRL::left", XS_Audio__CD__VolumeRL_left);
        newXS_deffile("Audio::CD::VolumeRL::right", XS_Audio__CD__VolumeRL_right);

    /* Initialisation Section */

#line 124 "CD.xs"
    boot_Audio__CD_constants();
    cddb_inexact_selection_set(inexact_select_func);

#line 2118 "CD.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
